; Programs for using Gray code (cyclic) addresses

(DEFCONSTANT CB-SZ 18) ; Field size for cube address

(*PROCLAIM '(TYPE (FIELD-PVAR CB-SZ) Hnx Hpr Vnx Vpr))

(*DEFVAR Hnx (!! 0))   ; Next processor in cycle
(*DEFVAR Hpr (!! 0))   ; Previous processor in cycle
(*DEFVAR Vnx (!! 0))   ; Alternate cycle
(*DEFVAR Vpr (!! 0))   ;    do.

; Set up cycles in nx, pr.  Cycle length = 2**c in steps of 2**d.

(*DEFUN mkgray (nx pr c d)
 "(mkgray nx pr c d) -- make cycle of 2**c step 2**d in nx, pr."
 (declare (type (field-pvar CB-SZ) nx pr) (type fixnum c d))
 (let ((mask (ash (1- (ash 1 c)) d)) (b (ash 1 d)))
      (declare (type fixnum mask b))
  (*let* ((bx (zerop!! (logand!! (self-address!!) (!! mask))))
          (cx bx) da)
         (declare (type boolean-pvar bx cx) (type (field-pvar CB-SZ) da))
    (*set nx (logand!! (self-address!!) (!! (lognot mask))))
    (*set pr nx)
    (*when cx (*set nx (logior!! nx (!! b))) (*set pr nx))
    (*when (eql!! (logand!! (self-address!!) (!! mask)) (!! b))
           (*set cx t!!))
    (dotimes (i (1- c))
      (*when cx
        (*when (zerop!! (logand!! nx (!! mask)))
               (*set nx (logior!! nx (!! (* 3 b)))))
        (setq b (ash b 1))
        (*when bx (*set pr (logior!! (self-address!!) (!! b))))
        (*set da  (logior!! (self-address!!) (!! b)))
        (*pset :default (logxor!! pr (!! b)) nx da)
        (*pset :default (logxor!! nx (!! b)) pr da)
        (*pset :default t!! cx da)
      )))
 ))

; Test program

(*PROCLAIM '(TYPE FLOAT-PVAR FX FY))

(*DEFVAR FX (/!! (random!! (!! 1000000)) (!! 1.0E6)))
(*DEFVAR FY (!! 0.0))

(DEFUN GTIME (N)
 (dotimes (i n) (*pset :default FX FX hnx))
)

(*PROCLAIM '(TYPE BOOLEAN-PVAR EVNP))

(*DEFUN EVENPARITY!! (X)
 (*LET ((p t!!)) (DECLARE (TYPE BOOLEAN-PVAR p))
  (dotimes (i 18)
   (*when (not!! (zerop!! (logand!! x (!! 1)))) (*set p (not!! p)))
   (*set x (ash!! x (!! -1)))
  )
  p))

(*DEFVAR EVNP (EVENPARITY!! (SELF-ADDRESS!!)))

(DEFUN GTM2 (c d n)
 (cm:time (mkgray hnx hpr c d))
 (cm:time
  (dotimes (k n)
   (*if evnp (*pset :default fx fy hnx) (*pset :default fx fy hnx))
   (*set fx fy)
  ))
)

(DEFUN FTM (k n)
 "Times n *psets along dimension k"
 (let ((bit (ash 1 k)))
   (*set vnx (logior!!  (self-address!!) (!! bit)))
   (cm:time (*when (zerop!! (logand!! (self-address!!) (!! bit)))
                (dotimes (i n) (*pset :default fx fy vnx))))
 ))